/*                           PULLDN20.MOD

                       Pull Down SysOp menus
                      for WWIV 4.10 or later

                             Version 2.0

                    by One Eyed Willy 1 @18851


Due to the incredible response to Pulldown 1.0, I have decided
to further work on the project.  Kermit Wodall of Inn of the Last Home
suggested I make more menus for the WFC, and so I have.  This version
also uses less code space than the other, due to my getting rid of
all the padding spaces and replacing them with a function.

        This also fixes a bug when running WWIV with many screen
lines (It has always made me laugh, there are a few mods out there
to run WWIV in 43/50 line mode, gee, its so hard to load the mode43
from your utilities disk and then run WWIV, plus, 43-50 line mode
is pretty useless anyway, its just too small to read for normal use
at least.)

        Other bugs fixed: Comptype problem, topscreen problem (fixed
in 1.1), and a problem concerning TC 2.0 and before's lack of ability
to turn off the cursor.  Basically, remove a #define at the beginning
of the mod (Clearly identified), and it will compile under TC 2.0 or
before.

        Using the menus - Using these is very very simple, F1 will
bring up the menus.  When a user is on-line, its a replacement for
the old box that allows you to change the user's SL.  From the WFC,
it basically gives you a nicer way of entering all the commands.


--- Programmer's Note:

        You might wanna take these pulldowns and put them into a separate
file, and overlay them.  But this requires knowledge of either the TC++
IDE, or knowledge of how to edit the makefile.  Nonetheless, if you
undertstand those two, I highly suggest overlaying these menus.

        The WFC menus work more or less by a kludge, but its an efficient
one.  Whenever you select an option from the menus, it "translates" the
selection into a character return code, (i.e. "Force Net Callout"
returns a "/", which gets interpreted as if it were a normal keypress).
Some "extended ASCII" keys had to be added to handle "Quick logon"
and so forth.

--- Disclaimer:

        I take no responsibility for the losses that might be caused
by this mod.  I don't beleive there will be any losses, but hey, I've
seen everyone else's mods with these disclaimers, why not me?  Oh,
and if your dog gets run over, that not my fault either.


--- So, on with the mod! ---

Load file: CONIO.C

First, remove the val_cur_user() and makewindow() voids.  For the C
illiterate, this means moving the cursor to the line with

void val_cur user()  or void makewindow()
{ ....

and hitting ctrl-y until you reach the beginning of the
next void.

Now, move to the very end of the file, and block-read in this
section of code.  (if you don't know how to block read, hit
F1 for help).
==================================================================
*/


#define cursorcom     /* Remove this if not using TC++ */


void drop_to_dos(int shrink)
{
  int i;

  i=topline;
  topline=0;
  curatr=0x07;
  clrscrb();
  if (shrink)
    shrink_out(getenv("COMSPEC"),1,0,0,0);
  else
    do_remote(getenv("COMSPEC"),0);
  topline=i;
}

void outfast(char *s)
/* This RAPIDLY outputs ONE LINE to the screen only*/
{
  int i,i1;

  i1 = (wherey() * 80 + wherex()) *2 ;
  for (i=0;s[i]!=0;i++) {
    scrn[i*2+i1+1]=curatr;
    scrn[i*2+i1]=s[i];
  }
  movecsr(wherex()+strlen(s),wherey());
}

void makewindow(int x, int y, int xlen, int ylen)
/* makewindow makes a window with the upper-left hand corner at (x,y), and the
   lower-right corner at (x+xlen,y+ylen) */
{
  int i,xx,yy;
  unsigned char s[81];

  if (xlen>80)
    xlen=80;
  if (ylen>(screenbottom+1-topline))
    ylen=(screenbottom+1-topline);
  if ((x+xlen)>80)
    x=80-xlen;
  if ((y+ylen)>screenbottom+1)
    y=screenbottom+1-ylen;

  xx=wherex();
  yy=wherey();
  for (i=1; i<xlen-1; i++)
    s[i]=196;
  s[0]=218;
  s[xlen-1]=191;
  s[xlen]=0;
  movecsr(x,y);
  outfast(s);
  s[0]=192;
  s[xlen-1]=217;
  movecsr(x,y+ylen-1);
  outfast(s);
  for (i=1; i<xlen-1; i++)
   "Si]=32;
  s[0]=179;
  s[xlen-1]=179;
  for (i=1; i<ylen-1; i++) {
    movecsr(x,i+y);
    outfast(s);
  }
  movecsr(xx,yy);
}


void prmnop(int which, int select, int lgt)
{
  char s[80],s1[80],s2[80];

  curatr=select ? 0x70 : 0x1f;
  switch(which) {
  case 0:
    movecsr(4,1);
    strcpy(s,"User Access");
    break;
  case 1:
    movecsr(27,1);
    strcpy(s,"Utilities");
    break;
  case 2:
    movecsr(48,1);
    strcpy(s,"Extra Commands");
    break;
  case 3:
    movecsr(4,4);
    strcpy(s,"User Level");
    break;
  case 4:
    movecsr(4,5);
    strcpy(s,"Xfer Level");
    break;
  case 5:
    movecsr(4,6);
    strcpy(s,"ARs");
    break;
  case 6:
    movecsr(4,7);
    strcpy(s,"DARs");
    break;
  case 7:
    movecsr(4,8);
    strcpy(s,"Restrictions");
    break;
  case 8:
    movecsr(4,9);
    strcpy(s,"User Gold");
    break;
  case 9:
    movecsr(4,10);
    strcpy(s,"User Exempt");
    break;
  case 10:
    movecsr(4,11);
    strcpy(s,"User Note");
    break;
  case 11:
    movecsr(4,12);
    strcpy(s,"User Handle");
    break;
  case 12:
    movecsr(4,13);
    strcpy(s,"User Password");
    break;
  case 13:
    movecsr(4,14);
    strcpy(s,"Show User Info");
    break;

  /* Cases 12-19 are reserved */

  case 20:
    movecsr(27,4);
    strcpy(s,incom ? "Disable Modem Input" : "Enable Modem Input");
    break;
  case 21:
    movecsr(27,5);
    strcpy(s,outcom ? "Disable Modem Output" : "Enable Modem Output");
    break;
  case 22:
    movecsr(27,6);
    strcpy(s,global_handle ? "Disable Capture" :
                            "Enable Capture");
    break;
  case 23:
    movecsr(27,7);
    strcpy(s,"Hang Up On User");
    break;
  case 24:
    movecsr(27,8);
    strcpy(s,"HangUp w/ Line Noise");
    break;
  case 25:
    movecsr(27,9);
    strcpy(s,"Give User Finger");
    break;
  case 26:
    movecsr(27,10);
    strcpy(s,"Change Time Left");
    break;

  /* Cases 27-39 are reserved */

  case 40:
    movecsr(47,4);
    strcpy(s,"Drop to DOS, Part Memory");
    break;
  case 41:
    movecsr(47,5);
    strcpy(s,"Drop to DOS, Full Memory");
    break;
  case 42:
    movecsr(47,6);
    strcpy(s,"Send File via Zmodem");
    break;
  case 43:
    movecsr(47,7);
    strcpy(s,"Send File via Ymodem");
    break;
  case 44:
    movecsr(47,8);
    strcpy(s,"Send File via Ascii");
    break;

  /* Cases 44-59 are reserved */

  case 60:
    movecsr(4,1);
    strcpy(s,"Log On");
    break;
  case 61:
    movecsr(27,1);
    strcpy(s,"Utilities");
    break;
  case 62:
    movecsr(48,1);
    strcpy(s,"BBS Editors");
    break;
  case 63:
    movecsr(4,4);
  strcpy(s,"Log on as Sysop");
    break;
  case 64:
    movecsr(4,5);
    strcpy(s,"Log on normally");
    break;
  case 65:
    movecsr(4,6);
    strcpy(s,"Answer Phone");
    break;
  case 66:
    movecsr(4,7);
    strcpy(s,"Drop to DOS, Part Memory");
    break;
  case 67:
    movecsr(4,8);
    strcpy(s,"Drop to DOS, Full Memory");
    break;
  case 68:
    movecsr(4,9);
    strcpy(s,"Run Terminal Program");
    break;
  case 69:
    movecsr(4,10);
    strcpy(s,"Quit BBS");
    break;

  /* Cases 70-79 are reserved. */

  case 80:
    movecsr(27,4);
    strcpy(s,"Read Today's Log");
    break;
  case 81:
    movecsr(27,5);
    strcpy(s,"Read Activity Log");
    break;
  case 82:
    movecsr(27,6);
    strcpy(s,"Read Network Log");
    break;
  case 83:
    movecsr(27,7);
    strcpy(s,"Send User a Message");
    break;
  case 84:
    movecsr(27,8);
    strcpy(s,"Read Feedback");
    break;
  case 85:
    movecsr(27,9);
    strcpy(s,"Read All Mail");
    break;
  case 86:
    movecsr(27,10);
    strcpy(s,"Force Net Callout");
    break;
  case 87:
    movecsr(27,11);
    strcpy(s,"System Statistics");
    break;
  case 100:
    movecsr(47,4);
    strcpy(s,"User Editor");
    break;
  case 101:
    movecsr(47,5);
    strcpy(s,"Chains Editor");
    break;
  case 102:
    movecsr(47,6);
    strcpy(s,"Board Editor");
    break;
  case 103:
    movecsr(47,7);
    strcpy(s,"Directory Editor");
    break;
  case 104:
    movecsr(47,8);
    strcpy(s,"G-File Editor");
    break;
  case 105:
    movecsr(47,9);
    strcpy(s,"Vote Editor");
    break;
  case 106:
    movecsr(47,10);
    strcpy(s,"Text File Editor");
    break;
  }
  sprintf(s1,lgt ? " %%-%ds" : " %%s " ,lgt);
  sprintf(s2,s1,s);
  outfast(s2);
}

void prst(char *stat, char *val,char *stat2, char *val2)
{
  char s[80];

  sprintf(s,"%-13s: ",stat);
  outfast(s);
  curatr--;
  outfast(val);
  curatr++;
  movecsr(55,wherey());
  sprintf(s,"%-11s: ",stat2);
  outfast(s);
  curatr--;
  outfast(val2);
  curatr++;
  movecsr(8,wherey()+1);
}

char action(int acton)

/* Act on a menu command.  Exitm has two functions:
   1. Determine wether menus will remain on-screen
   2. Return a character code for the WFC menus   */

{
  char sl[4],dsl[4],exempt[4],sysopsub[4],ar[17],dar[17],restrict[17],rst[17],
       tl[50],gold[5],tleft[4],onam[31],s[80],exitm;
  char far *oldscr;
  int i,i1,done,oatr,rc;
  double newt;

  oldscr=farmalloc(screenlen);

#ifdef cursorcom
  _setcursortype(_NORMALCURSOR);
#endif

  itoa((int)thisuser.sl,sl,10);
  itoa((int)thisuser.dsl,dsl,10);
  itoa((int)thisuser.exempt,exempt,10);
  itoa((int)thisuser.sysopsub,sysopsub,10);
  itoa((int)thisuser.gold,gold,10);
  strcpy(onam,thisuser.name);
  strcpy(rst,restrict_string);
  for (i=0; i<=15; i++) {
    if (thisuser.ar & (1 << i))
      ar[i]='A'+i;
    else
      ar[i]=32;
      if (thisuser.dar & (1 << i))
      dar[i]='A'+i;
    else
      dar[i]=32;
    if (thisuser.restrict & (1 << i))
      restrict[i]=rst[i];
    else
      restrict[i]=32;
  }
  dar[16]=0;
  ar[16]=0;
  restrict[16]=0;
  exitm=0;
  memmove(oldscr,scrn,screenlen);
  curatr=0x4f;
  switch(acton) {
  case 3:
    makewindow(6,5,18,3);
    movecsr(8,5);
    outfast("[ User Level ]");
    movecsr(13,6);
    editline(sl,3,NUM_ONLY,&rc,"");
    thisuser.sl=(char) atoi(sl);
    itoa((int)thisuser.sl,sl,10);
    sprintf(tl,"%-3s",sl);
    outfast(tl);
    wait1(4);
    break;
  case 4:
    makewindow(6,6,18,3);
    movecsr(8,6);
    outfast("[ Xfer Level ]");
    movecsr(13,7);
    editline(dsl,3,NUM_ONLY,&rc,"");
    thisuser.dsl=(char) atoi(dsl);
    itoa((int)thisuser.dsl,dsl,10);
    sprintf(tl,"%-3s",dsl);
    outfast(tl);
    wait1(4);
    break;
  case 5:
    makewindow(6,7,18,3);
    movecsr(8,7);
    outfast("[ User AR's  ]");
    movecsr(7,8);
    editline(ar,16,SET,&rc,"ABCDEFGHIJKLMNOP");
    thisuser.ar=0;
    for (i=0; i<=15; i++)
    if (ar[i]!=32)
        thisuser.ar |= (1 << i);
    break;
  case 6:
    makewindow(6,8,18,3);
    movecsr(8,8);
    outfast("[ User DAR's ]");
    movecsr(7,9);
    editline(dar,16,SET,&rc,"ABCDEFGHIJKLMNOP");
    thisuser.dar=0;
    for (i=0; i<=15; i++)
      if (dar[i]!=32)
        thisuser.dar |= (1 << i);
    break;
  case 7:
    makewindow(6,9,18,3);
    movecsr(7,9);
    outfast("[ Restrictions ]");
    movecsr(7,10);
    editline(restrict,16,SET,&rc,rst);
    thisuser.restrict=0;
    for (i=0; i<=15; i++)
      if (restrict[i]!=32)
        thisuser.restrict |= (1 << i);
    break;
  case 8:
    makewindow(6,10,19,3);
    movecsr(8,10);
    outfast("[ User Gold ]");
    movecsr(12,11);
    editline(gold,4,NUM_ONLY,&rc,"");
    thisuser.gold=(int)atoi(gold);
    sprintf(tl,"%-4s",gold);
    outfast(tl);
    wait1(4);
    break;
  case 9:
    makewindow(6,11,19,3);
    movecsr(8,11);
    outfast("[ User Exempt ]");
    movecsr(13,12);
    editline(exempt,3,NUM_ONLY,&rc,"");
    thisuser.exempt=(char)atoi(exempt);
    sprintf(tl,"%-3s",exempt);
    outfast(tl);
    wait1(4);
    break;
  case 10:
    makewindow(6,12,42,3);
    movecsr(20,12);
    outfast("[ User Note ]");
    movecsr(7,13);
    editline(thisuser.note,40,ALL,&rc,"");
    for(i=strlen(thisuser.note)-1;i>0 && thisuser.note[i]==32;i--);
      thisuser.note[i+1]=0;
    break;
  case 11:
    makewindow(6,13,32,3);
    movecsr(15,13);
    outfast("[ User Handle ]");
    movecsr(7,14);
    editline(onam,30,UPPER_ONLY,&rc,"");
    for(i=strlen(onam)-1;i>=0 && onam[i]==32;i--);
    onam[i+1]=0;
    if (onam[0]) {
      if (finduser(onam)<1) {
        dsr(thisuser.name);
        strcpy(thisuser.name,onam);
        isr(usernum,thisuser.name);
      }
    }
    break;
  case 12:
    makewindow(6,13,14,3);
    movecsr(7,13);
    outfast("[ Password ]");
    movecsr(9,14);
    editline(thisuser.pw,8,UPPER_ONLY,&rc,"");
    for(i=strlen(thisuser.pw)-1;i>=0 && thisuser.pw[i]==32;i--);
    thisuser.pw[i+1]=0;
    break;
  case 13:
    makewindow(6,8,72,12);
    movecsr(8,9);
    prst("User Handle",thisuser.name,"User Lev",sl);
    prst("Real Name",thisuser.realname,"Xfer Lev",dsl);
    prst("Phone",thisuser.phone,"Uploaded",itoa(thisuser.uploaded,s,10));
    prst("Computer",ctypes[thisuser.comp_type],"Upload K",ltoa(thisuser.uk,s,10));
    prst("Password",thisuser.pw,"Downloaded",itoa(thisuser.downloaded,s,10));
    prst("ARs",ar,"Download K",ltoa(thisuser.dk,s,10));
    prst("DARs",dar,"User Gold",itoa(thisuser.gold,s,10));
    prst("Restriction",restrict,"Msg Read",ltoa(thisuser.msgread,s,10));
    prst("Last on",thisuser.laston,"Msg Posted",
                            ltoa(thisuser.msgpost+thisuser.postnet,s,10));
    outfast("User Note    : ");
    curatr--;
    outfast(thisuser.note);
    curatr++;
    getchd();
    break;
  case 20:
    incom=!incom;
    break;
  case 21:
    outcom=!outcom;
    break;
  case 22:
    set_global_handle(!global_handle);
    break;
  case 23:
    hangup=1;
    exitm=1;
    break;
  case 24:
    restorescreen(&screensave);
    i1=(rand() % 20) + 570;
    for (i=0; i<i1 && cdet(); i++)
      outchr(rand() % 256);
    hangup=1;
    exitm=1;
    dtr(0);
    savescreen(&screensave);
    break;
  case 25:
    restorescreen(&screensave);
    pr_wait(0);
    printfile("FINGER");
    pr_wait(1);
    savescreen(&screensave);
    memmove(scrn,oldscr,screenlen);
    break;
  case 26:
    itoa((int)(nsl()/60.0),tleft,10);
    makewindow(6,10,19,3);
    movecsr(9,10);
    outfast("[ Mins Left ]");
    movecsr(12,11);
    editline(tleft,4,NUM_ONLY,&rc,"");
    newt=(float)atoi(tleft)*60;
    thisuser.extratime+=newt-nsl();
    break;
  case 40:
    drop_to_dos(0);
    break;
  case 41:
    drop_to_dos(1);
    break;
  case 42:
  case 43:
  case 44:
    makewindow(6,12,66,3);
    movecsr(25,12);
    switch(acton) {
    case 42:
      outfast("[ Zmodem Send File ]");
      break;
    case 43:
      outfast("[ Ymodem Send File ]");
      break;
    case 44:
      outfast("[ ASCII Send File  ]");
      break;
    }
    s[0]=0;
    movecsr(7,13);
    editline(s,64,UPPER_ONLY,&rc,"");
    for(i=strlen(s)-1;i>=0 && s[i]==12;i--);
    s[i+1]=0;
    if(s[0] && exist(s)) {
      restorescreen(&screensave);
      pr_wait(0);
      nl();
      switch(acton) {
      case 42:
        pl("Zmodem Send Commencing...");
        extern_prot(0,s,1);
        break;
      case 43:
        pl("Xmodem 1k Send Commencing...");
        xymodem_send(s,&i,&newt,0,1,1,0);
        break;
      case 44:
        pl("ASCII Send Commencing, Press a key to begin...");
        getkey();
        ascii_send(s,&i,&newt);
        break;
      }
      nl();
      exitm=1;
      savescreen(&screensave);
    }
    break;
  case 63:
    exitm=177;
    break;
  case 64:
    exitm=178;
    break;
  case 65:
    exitm='A';
    break;
  case 66:
    exitm='F';
    break;
  case 67:
    curatr=0x07;
    clrscrb();
    shrink_out(getenv("COMSPEC"),0,0,0,0);
    exitm=1;      /* Incase you "Can't shrink" */
    break;
  case 68:
    exitm='T';
    break;
  case 69:
    exitm='Q';
    break;
  case 80:
    exitm='L';
    break;
  case 81:
    exitm='Z';
    break;
  case 82:
    exitm='N';
    break;
  case 83:
    exitm='W';
    break;
  case 84:
    exitm='R';
    break;
  case 85:
    exitm='M';
    break;
  case 86:
    exitm='/';
    break;
  case 87:
    exitm='S';
    break;
  case 100:
    exitm='U';
    break;
  case 101:
    exitm='C';
    break;
  case 102:
    exitm='B';
    break;
  case 103:
    exitm='D';
    break;
  case 104:
    exitm='G';
    break;
  case 105:
    exitm='I';
    break;
  case 106:
    exitm='E';
    break;
  }

#ifdef cursorcom
  _setcursortype(_NOCURSOR);
#endif

  if (!exitm)
    memmove(scrn,oldscr,screenlen);
  farfree(oldscr);
  return(exitm);
}


char domenu(int *returncode,int lo,int numop, int mnus, int mnulen)
{
  int i,ch,pos,opos,done;
  char far *oldscr,rc;

  oldscr=farmalloc(screenlen);

#ifdef cursorcom
  _setcursortype(_NOCURSOR);
#endif

  memmove(oldscr,scrn,screenlen);
  makewindow(mnus,3,mnulen,numop+3);
  for(i=lo;i<numop+lo+1;i++)
    prmnop(i,0,0);
  pos=0;
  done=0;
  rc=0;
  do {
    opos=pos+lo;
    prmnop(opos,1,mnulen-3);
    ch=getchd();
    
    if (ch==0) {
      ch=getchd();
      switch (ch) {
      case 59:
        done=1;
        *returncode=4;
        break;
      case 71: pos=0; break;
      case 79: pos=numop; break;
      case 80:
        if (pos<numop)
          pos++;
        else
          pos=0;
        break;
      case 72:
        if (pos>0)
          pos--;
        else
          pos=numop;
        break;
      case 75:
      case 15:
        done=1;
        *returncode=*returncode-1;
        if (*returncode<0)
        *returncode=2;
        break;
      case 77:
        done=1;
        *returncode=*returncode+1;
        if (*returncode>2)
          *returncode=0;
        break;
      }
    } else {
      switch(ch) {
      case 27:
        done=1;
        *returncode=4;
        break;
      case 13:
        rc=action(pos+lo);
        if (rc) {
          *returncode=4;
          done=1;
        }
        break;
      }
    }
    prmnop(opos,0,mnulen-3);
  } while (!done);
  memmove(scrn,oldscr,screenlen);
  farfree(oldscr);

#ifdef cursorcom
  _setcursortype(_NORMALCURSOR);
#endif

  return(rc);
}


void val_cur_user()
{
  
  int cp, done, i, tl;

  thisuser.sl=realsl;
  pr_wait(1);
  tl=topline;
  topline=0;
  savescreen(&screensave);
  curatr=0x1f;
  makewindow(0,0,79,3);
  for(i=0;i<3;i++)
    prmnop(i,0,0);
  cp=0;
  done=0;
  while (!done) {
    i=curatr;
    if (cp<4)
      prmnop(cp,1,0);
    curatr=i;
    i=cp;
    switch(cp) {
    case 0:
      domenu(&cp,3,10,3,18);
      break;
    case 1:
      domenu(&cp,20,6,26,24);
      break;
    case 2:
      domenu(&cp,40,4,46,28);
      break;
    case 3:
      out1ch(7);
      cp=1;
      break;
    case 4:
      done=1;
      break;
    }
    prmnop(i,0,0);
  }
  restorescreen(&screensave);
  topline=tl;
  changedsl();
  pr_wait(0);
}

char wfc_menu()
{
  
  int cp, done, i, tl;
  char rc;

  tl=topline;
  topline=0;
  savescreen(&screensave);
  curatr=0x1f;
  makewindow(0,0,79,3);
  for(i=0;i<3;i++)
    prmnop(i+60,0,0);
  cp=0;
  done=0;
  while (!done) {
    i=curatr;
    if (cp<4)
      prmnop(cp+60,1,0);
    curatr=i;
    i=cp;
    switch(cp) {
    case 0:
      rc=domenu(&cp,63,5,3,28);
      break;
    case 1:
      rc=domenu(&cp,80,7,26,23);
      break;
    case 2:
      rc=domenu(&cp,100,6,46,20);
      break;
    case 3:
      out1ch(7);
      cp=1;
      break;
    case 4:
      done=1;
      break;
    }
    prmnop(i+60,0,0);
  }
  restorescreen(&screensave);
  topline=tl;
  return(rc);
}

/*
========================================================================

Now, to deal with the WFC menus.  They aren't as simple a task.  But then
again, after entering mods such as the Byline mod, this will make you
feel as if you were on christmas vacation..



Load up BBS.C, and search (Ctrl-K S) for the following lines:

void getcaller()
{
  char s[81],s1[81],ch,done,lokb;
  int i,i1,i2,i3;

and modify it to read:


void getcaller()
{

  char s[81],s1[81],done,lokb;
  int i,i1,i2,i3;
  unsigned char ch;   /* It'll give warnings w/o the Unsigned */


Then, search for the following:

    okskey=0;
    ch=upcase(inkey());
    if (ch) {
      switch(ch) {
        case '?':

and replace with:

    okskey=0;
    if (kbhit()) {
      ch=getchd();
      if (ch==0 && getchd()==59)
        ch=wfc_menu();
    } else
      ch=0;
    ch=toupper(ch);
    if (ch) {
      switch(ch) {
        case '?':



   That will get most of it active, but you have to do one
more simple change to the "Log on? " proceedure....:

A few more lines down, search for:

        case ' ':
          outs("Log on? ");
          d=timer();
          while ((!kbhitb()) && (fabs(timer()-d)<60.0));
          if (kbhitb()) {
            ch=upcase(getchd1());
            if (ch=='Y') {
              outs("Yes\r\n");
              lokb=1;
              if ((syscfg.sysconfig & sysconfig_off_hook)==0)
                dtr(0);
            }
            if ((ch=='F') && (ok_local())) {
              outs("Fast\r\n\r\n\r\n\r\n\r\n\r\n");

          /* ^^^^ What's this, a subliminal message?! */

              read_user(1,&thisuser);

and replace with:

        case 178:
        case 177:   /* Yes, 3 of them. */
        case ' ':
          outfast("Log on locally? ");
          d=timer();
          while ((!kbhit()) && (fabs(timer()-d)<60.0) && ch<177);
          if (kbhit() || ch>176) {
            if (ch<177)
              ch=toupper(getchd1());
            if (ch=='Y' || ch==178) {
              lokb=1;
              if ((syscfg.sysconfig & sysconfig_off_hook)==0)
                dtr(0);
            }
            if ((ch=='F' || ch==177) && (ok_local())) {
              read_user(1,&thisuser);



And that should just about do it.. If all goes well, it will compile
with no errors.  As soon as the BBS loads, go ahead and hit F1 to
see the WFC menus, and log on using them.  Then edit yourself.  Lower
your time to 1. Give yourself a 2 sl. It all should work.  If something
doesn't, then e-mail 1@18852 Link and bitch away, i'll do my best.


Hope you enjoy this mod!

-

